///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 
// Copyright Nurve Networks LLC 2009
// 
// Filename: CHAM_PIC_MOUSE_DRV_V010.C
//
// Original Author: Andre' LaMothe
// 
// Last Modified: 8.28.09
//
// Description: 
//  
// Overview:
//
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// INCLUDES ///////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// include local Chameleon PIC API header files
#include "CHAM_PIC_SYSTEM_V010.h"
#include "CHAM_PIC_I2C_SPI_DRV_V010.h"
#include "CHAM_PIC_MOUSE_DRV_V010.h"


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MACROS /////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// DEFINES/////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// TYPES/CLASSES //////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// GLOBALS ////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// EXTERNALS //////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// PROTOTYPES /////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// FUNCTIONS  /////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Mouse support
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int Mouse_Read(gid_event_ptr mouse)
{
// this reads the mouse delta position and button state and stores the results in the sent mouse record

#define MOUSE_DELAY_SCALE 2 // this local scale factor helps tune this delays for a longer critical path thru the driver
                            // use larger number if things get funky

//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// read delta x position first
SPI_Prop_Send_Cmd( MOUSE_CMD_DELTA_X, 0x00, 0x00); 
//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// now read data from SPI buffer
mouse->x = SPI_Prop_Send_Cmd( READ_CMD, 0x00, 0x00); 
//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// read delta y position 
SPI_Prop_Send_Cmd( MOUSE_CMD_DELTA_Y, 0x00, 0x00); 
//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// now read data from SPI buffer
mouse->y = SPI_Prop_Send_Cmd( READ_CMD, 0x00, 0x00); 
//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// read delta z position 
SPI_Prop_Send_Cmd( MOUSE_CMD_DELTA_Z, 0x00, 0x00); 
//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// now read data from SPI buffer
mouse->z = SPI_Prop_Send_Cmd( READ_CMD, 0x00, 0x00); 
//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// read buttons 
SPI_Prop_Send_Cmd( MOUSE_CMD_BUTTONS, 0x00, 0x00); 
//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// now read data from SPI buffer
mouse->buttons = SPI_Prop_Send_Cmd( READ_CMD, 0x00, 0x00); 
//DELAY_US(MOUSE_DELAY_SCALE*SPI_PROP_DELAY_LONG_US);

// return success
return(1);

} // end Mouse_Read

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int Mouse_Load(void)
{
// this loads the mouse driver
SPI_Prop_Send_Cmd( MOUSE_CMD_START, 0x00, 0x00);

// wait a bit, driver takes time to respond...
//DELAY_US(SPI_PROP_DELAY_LONG_US);

// return success
return(1);

} // end Mouse_Load

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int Mouse_Unload(void)
{
// this unloads the mouse driver
SPI_Prop_Send_Cmd( MOUSE_CMD_STOP, 0x00, 0x00);

// wait a bit, driver takes time to respond...
//DELAY_US(SPI_PROP_DELAY_LONG_US);

// return success
return(1);

} // end Mouse_Unload

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
